apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  name: git-push
  namespace: ci
spec:
  description: >-
    Cette tache va nous permettre de push sur un repos git. Pour permettre cette action, nous allons monter en volume 
    le secret. Ensuite nous allons copier la cle ssh en root avec les bonnes permissions. 
    nous ajoutons StrictHostKeyChecking à no afin qu'il ne pose aucunes questions et ajoute automatiquement la nouvelle cle
    d hotes dans le fichier /known_hosts.
    Nous définissons un mail / username en plus. 

    Un workspace est utilisé ainsi que le volumemount qui nous sert a passer le secret contenant le rsa 
    et known_host de gitlab.
  params:
    - name: APP_NAME
      type: string
    - name: DIRECTORY
      type: string
    - name: IMAGE_RELEASE
      type: string
    - name: GIT_EMAIL
      type: string
    - name: GIT_USERNAME
      type: string
    - name: GIT_BRANCH
<<<<<<< HEAD
      type: string
    - name: DIR_REPO
=======
>>>>>>> 6a206edb7da11c4225c0cbb0d667fe038327b610
      type: string
  steps:
    - image: alpine/git
      name: ''
      resources: {}
      script: |
        #!/usr/bin/env sh       
        mkdir -m 750 /root/.ssh/
        cp /git/.ssh/ssh-privatekey /root/.ssh/id_rsa
        echo 'StrictHostKeyChecking no' >> /root/.ssh/config
        chmod 600 /root/.ssh/id_rsa

        cd $(params.DIR_REPO)

        git config --global --add safe.directory '*'
        git config user.email $(params.GIT_EMAIL)  

        git config user.name $(params.GIT_USERNAME)

        git checkout $(params.GIT_BRANCH)
        touch test

        git add . 

        git commit -a -m $(params.IMAGE_RELEASE)

        git push
      volumeMounts:
        - mountPath: /git/.ssh
          name: sshcfg
      workingDir: $(params.DIRECTORY)
  volumes:
    - name: sshcfg
      secret:
        secretName: ssh-gitlab-ste-sec
  workspaces:
    - description: my workspace
      name: output
